Subject: RE: the protocols for the M/O flags (Re: [rfc2462bis] whether we need the M/O flags)

From: "Christian Huitema" <[email-masked]>
Date: Wed, 28 Apr 2004 09:29:23 -0700

I think a whole lot of the issue has to do with the supposedly mandatory nature of the M flag, which leads to phrases like "do DHCP, and only if it fails do auto-config." It would be much simpler to simply define the flags as "announcing an available service", as in:

1) The "M" flag is set to indicate that a DHCPv6 address configuration service is available on this link, as specified in RFC3315.

2) The "O" flag is set to indicate that a DHCPv6 information service is available on this link, as specified in RFC3736.

We should then leave it at that, and leave it to nodes to decide whether they want to use these services or not. For example, a server with a configured address will never use DHCPv6 address configuration; an appliance that never has to resolve DNS names will never use the information service. By setting the flags to indicate service availability, we will reduce the amount of useless chatter on the link when the services are not in fact available.

We should note that, from a protocol point of view, there is no need to use the M bit to control stateless address configuration. This function is already achieved by the "Autonomous flag" in the prefix information option. If the flag is not set, the hosts will not configure information from the prefix. 

-- Christian Huitema

--------------------------------------------------------------------
IETF IPv6 working group mailing list
[email-masked]
Administrative Requests: https://www1.ietf.org/mailman/listinfo/ipv6
--------------------------------------------------------------------

---

From: Tim Hartrick <[email-masked]>
Date: 28 Apr 2004 10:13:59 -0700

Christian,

On Wed, 2004-04-28 at 09:29, Christian Huitema wrote:
> I think a whole lot of the issue has to do with the supposedly mandatory nature
> of the M flag, which leads to phrases like "do DHCP, and only if it fails do
> auto-config." It would be much simpler to simply define the flags as
> "announcing an available service", as in:
> 

Hmmm...  My understanding of RFC 2462 section 5.5.3 is that it already
treats the M flag as you said it should.  That is, the M flag does not
prohibit the processing of prefix options.  The same is true of the O
flag.  Is there text elsewhere which implies otherwise?

> 1) The "M" flag is set to indicate that a DHCPv6 address configuration service
> is available on this link, as specified in RFC3315.
> 
> 2) The "O" flag is set to indicate that a DHCPv6 information service is
> available on this link, as specified in RFC3736.
> 
> We should then leave it at that, and leave it to nodes to decide whether they
> want to use these services or not. For example, a server with a configured
> address will never use DHCPv6 address configuration; an appliance that never
> has to resolve DNS names will never use the information service. By setting
> the flags to indicate service availability, we will reduce the amount of
> useless chatter on the link when the services are not in fact available.

I think that this is the approach that was originally intended.  If
there is text in the RFC which says that the M flag and auto-config are
mutually exclusive, that text is wrong and should be corrected.

Tim Hartrick
Mentat Inc.

---

From: Iljitsch van Beijnum <[email-masked]>
Date: Wed, 28 Apr 2004 19:53:18 +0200

On 28-apr-04, at 18:29, Christian Huitema wrote:

> We should note that, from a protocol point of view, there is no need 
> to use the M bit to control stateless address configuration. This 
> function is already achieved by the "Autonomous flag" in the prefix 
> information option. If the flag is not set, the hosts will not 
> configure information from the prefix.

Christian, you are overlooking the possible situation where address 
configuration through DHCP is desired, but there are also hosts that 
don't support DHCP. In this case stateless address configuration can't 
be turned off.

---

From: Alain Durand <[email-masked]>
Date: Wed, 28 Apr 2004 11:46:08 -0700

On Apr 28, 2004, at 9:29 AM, Christian Huitema wrote:

> I think a whole lot of the issue has to do with the supposedly 
> mandatory nature of the M flag, which leads to phrases like "do DHCP, 
> and only if it fails do auto-config." It would be much simpler to 
> simply define the flags as "announcing an available service", as in:
>
> 1) The "M" flag is set to indicate that a DHCPv6 address configuration 
> service is available on this link, as specified in RFC3315.
>
> 2) The "O" flag is set to indicate that a DHCPv6 information service 
> is available on this link, as specified in RFC3736.
>
> We should then leave it at that, and leave it to nodes to decide 
> whether they want to use these services or not. For example, a server 
> with a configured address will never use DHCPv6 address configuration; 
> an appliance that never has to resolve DNS names will never use the 
> information service. By setting the flags to indicate service 
> availability, we will reduce the amount of useless chatter on the link 
> when the services are not in fact available.

I totally agree. More, there are cases where the hosts are using 
another external configuration
mechanisms and forcing them to use DHCPv6 would be inappropriate.

	- Alain.